function [outp, inp] = fourier2(fcn)
    ,
N=1024;
D=sqrt(N);
k = -N/2:N/2-1;
[xs,ys] = meshgrid(k*D/N);
dx = D/N;;
dy = D/N;


f = fcn(xs,ys);
A = sum(sum(f))*dx*dy;


subplot(1,2,1);
range = 4;
xr = k/D;
idx = find( (-range <= xr) & (xr<range) );
inp = abs(f(idx,idx));
imshow(inp);
x = xs(idx,idx);
y = ys(idx,idx);

z = fftshift(fft2(fftshift(f)))*(dx*dy/A);
fy = z.*conj(z);

subplot(1,2,2);

frange = 4;
idx = find( (-frange <= xr) & (xr<frange) );

outp = fy(idx,idx);
logim(outp,3);
